unit usignet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ugraftool;

type
  //Matrix = ARRAY[1..14] OF TPOINT; in der Unit DPGraftool deklariert

  Tfsignet = class(TForm)
    BitBtn1: TBitBtn;
    bzeichnen: TButton;
    eradius: TEdit;
    ewinkel: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    procedure bzeichnenClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  fsignet: Tfsignet;
  Signet : Matrix;

implementation

{$R *.dfm}

procedure Tfsignet.bzeichnenClick(Sender: TObject);
VAR z,r,w,x,y : INTEGER;

PROCEDURE Line(x1,y1,x2,y2 : INTEGER);
 BEGIN
  Canvas.MoveTo(x1,y1);
  Canvas.LineTo(x2,y2);
 END;

PROCEDURE Zeichne_Signet(s: Matrix);
BEGIN
{Bildschirm des Computers}
  Canvas.Rectangle(s[10].X, s[10].Y, s[11].X, s[11].Y);
  Canvas.Brush.Style:=bssolid;
  Canvas.Brush.Color:=clblue;
  Canvas.Rectangle(s[12].X, s[12].Y, s[13].X, s[13].Y);
  Canvas.Brush.Style:=bsclear; //sonst alles blau

{Gehuse des Computers}
  Canvas.Rectangle(s[14].X, s[14].Y, s[15].X, s[15].Y);

{Schlitze der Diskettenlaufwerke}
  Line(s[16].X, s[16].Y, s[17].X, s[17].Y);
  Line(s[18].X, s[18].Y, s[19].X, s[19].Y);

{Begrenzungspolygon}
  canvas.polygon(Slice(s,8));
END;

PROCEDURE Schrift(fh:INTEGER; s: Matrix);
VAR t1,t2 : STRING[10];
BEGIN
  t1:='PROFI';
  t2:='SOFT';
  Canvas.Font.Height:=fh;
  Canvas.TextOut(s[20].X - Canvas.TextWidth(t1) DIV 2, s[20].Y,t1);
  Canvas.TextOut(s[21].X - Canvas.TextWidth(t2) DIV 2, s[21].Y,t2);
END;

begin
 SetViewPortOrgEx(Canvas.Handle, fsignet.width DIV 2, fsignet.height DIV 2,nil);
 //Eingaben
 r:=STRTOINT(eradius.Text);
 w:=STRTOINT(ewinkel.Text);
 //Initialisiere
 x:=0;y:=0;
 //Verarbeitung
 FOR z:=1 TO TRUNC(360/w) DO
   BEGIN
    Signet_Daten(Signet);
    Verzerren(1/2,1/2,21,Signet); //immer erst verzerren, dann verschieben
    Mittelpunkt(r,z*w,x,y);       //neuen Mittelpunkt berechnen
    Verschieben(x,y,21,Signet);   //Verschiebung um x Pixel und um y Pixel von 0,0 aus
    Zeichne_Signet(Signet);
    Schrift(10,Signet);
   END;
end;

procedure Tfsignet.Button1Click(Sender: TObject);
begin
 REFRESH;
end;

end.
